#!/bin/bash

# usage: crunchdata.sh filename syscall block
#
# where:
#	filename : an output file from the Linux "strace -rp pid" command .
#	syscall  : the system call to look for. Example: pread64, pwrite64, etc.
#	block    : single block (sb) or multiblock (mb) call.
#
# example: ./crunchdata.sh lgwr_pwrite64_mb_12.trc pwrite64 mb >lgwr_pwrite64_mb_12.txt 2>&1 &
#

fn=$1
cmd=$2
blocktype=$3

cntr=0

cat $fn | 
while read line
do
  cntr=`echo "$cntr+1"|bc`
  if [[ $line == *$cmd* ]]
  then
    bytes=`echo $line | awk 'BEGIN { FS = ", " } ; { print $3 }'`
    nextline=`echo "$cntr+1"|bc`
    rt=`cat $fn | head -$nextline | tail -1 | awk '{print $1}'`
    rt=`echo "scale=12;1000*$rt"|bc`
    #echo "diag: cntr=$cntr bytes=$bytes rt=$rt line=$line"
    if [ $bytes -gt 8192 ]
    then
      if [ "$blocktype" = "mb" ]
      then
        echo "$rt"
      fi
    else if [ "$blocktype" = "sb" ]
      then
        echo "$rt"
      fi
    fi
  fi
done

