(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    136295,       4173]
NotebookOptionsPosition[    135485,       4146]
NotebookOutlinePosition[    135827,       4161]
CellTagsIndexPosition[    135784,       4158]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
   "filename1", "=", "\"\</Users/cshallah/Desktop/lgwr_2min.txt\>\""}], ";"}],
   "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "filename2", "=", "\"\</Users/cshallah/Desktop/testdata.txt\>\""}], ";"}],
    " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"filename1", ",", "\"\<List\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data2", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{
       RowBox[{"Mean", "[", "data", "]"}], ",", 
       RowBox[{"StandardDeviation", "[", "data", "]"}]}], "]"}], ",", 
     RowBox[{"Length", "[", "data", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", 
  RowBox[{
   RowBox[{"{", "data", "}"}], ",", 
   RowBox[{
   "PlotLabel", "\[Rule]", 
    "\"\<Occurrences vs LGWR pwrite64 duration (ms)\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"data", ",", "data2"}], "}"}], ",", 
   RowBox[{
   "PlotLabel", "\[Rule]", 
    "\"\<Occurrences vs LGWR pwrite64 duration (ms)\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", 
  RowBox[{
   RowBox[{"{", "data", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "150", ",", "1"}], "}"}], ",", 
   RowBox[{
   "PlotLabel", "\[Rule]", 
    "\"\<Occurrences vs LGWR pwrite64 duration (ms)\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", "data", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Mean", "[", "data", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Median", "[", "data", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quantile", "[", 
  RowBox[{"data", ",", "0.10"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quantile", "[", 
  RowBox[{"data", ",", "0.25"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quantile", "[", 
  RowBox[{"data", ",", "0.50"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quantile", "[", 
  RowBox[{"data", ",", "0.75"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quantile", "[", 
  RowBox[{"data", ",", "0.80"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quantile", "[", 
  RowBox[{"data", ",", "0.90"}], "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJwd0H0s1HEcB/C7Hk45ZOqyRUksl24x6Tnlksoi0pUeyHXlYYzsbHra6jx1
uiKXo6tsVBddInOo3TxTGde5LilTh6Ylkh5uuOtW/d7fPz577f3ZPtt7H1fB
6fCYWTQabSc10NU1Qy+wH+PaPbF9A3/2BRng6vHILzC7p3AKussniaLMTAss
vjr9Dy7i5zNOUvr6W4i1UpUzTOIEeMKRKy/94JAieQesujayB97Nbw+Bd94e
08OzUaMf4f6FPcOwKdlAZOUdmILmm2kWOFZZEpBIaez9TezMaTwNZxY8OQMN
VqZLcDzFJIIZdFMWtPFaJYFZeXQpnMz3JjrozqVexv1zHVGQVXEOZvyITIf6
p+f7Yd70ANGLu/ITZM/aShQOSehiSonxmTXcoeleBN1kPUT/qhMTMkre7E5i
jlv17EJKlWOJDZR/F7DgGiVzMdw+Yu0Ew9ViYmlvqAesM7/zhPcb33vBoyEP
fWAhr8Yfyua5c+Hf9M/7YMLMwjDIOcjj1eK/6VeIffJXfLhrXlkM1LUFTsHi
+dnE+i30pHrK5cfmCCE/52y/mvJbu+cHuOmhLq2ZckV60UWoUETkkixeJoMm
79tKsmfRH0Hnmrh62PI1TQ1jE5itUNTZ1QXrDJNamN+l74VrL1QMwG4/j2FY
PlfKbEHPolAbuOtjpj1sGjQ7wKr2X0uhRXvdBfrGatxgMCPaHdpapGz4KaiI
qK0Y2watuQFceMPKLhgecfwTAqMktAj4YWvZYei30ekUNP5TxUO2uaUBxp5f
1gjjWUHPoXB36Qt4b8j4CirYDC1sS6CJWykPyTnESGFCLtSI98qgOvW4HJoV
9eVwbnTBY2hfLVdBeaVPA2RuWE8MszW1wrSOxBcw5UC4Bs7oS4nNwxM6uCQw
6w180JxhgPzWqFHIvlRphDHKESJzUBfxmpIhWhcNOxoUcTD4ojIeclLVBbDA
7oIMbu4PvQVPjbnchv8BVzQXpg==
  "]],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {}, 
   {RGBColor[0.24720000000000014`, 0.24, 0.6], Opacity[0.5], EdgeForm[Opacity[
    0.7]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{0, 0}, {10, 409}]},
        ImageSizeCache->{{17.749999999999996`, 
         27.27548262548262}, {-87.6512462484858, 102.03778676483908`}}],
       StatusArea[#, 409]& ,
       TagBoxNote->"409"],
      StyleBox["409", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[409, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{10, 0}, {20, 190}]},
        ImageSizeCache->{{26.77548262548262, 36.30096525096525}, {
         13.65046091512825, 102.03778676483908`}}],
       StatusArea[#, 190]& ,
       TagBoxNote->"190"],
      StyleBox["190", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[190, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{20, 0}, {30, 180}]},
        ImageSizeCache->{{35.80096525096525, 45.32644787644787}, {
         18.276109644060398`, 102.03778676483908`}}],
       StatusArea[#, 180]& ,
       TagBoxNote->"180"],
      StyleBox["180", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[180, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{30, 0}, {40, 79}]},
        ImageSizeCache->{{44.82644787644787, 54.3519305019305}, {
         64.9951618062751, 102.03778676483908`}}],
       StatusArea[#, 79]& ,
       TagBoxNote->"79"],
      StyleBox["79", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[79, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40, 0}, {50, 33}]},
        ImageSizeCache->{{53.8519305019305, 63.37741312741312}, {
         86.27314595936299, 102.03778676483908`}}],
       StatusArea[#, 33]& ,
       TagBoxNote->"33"],
      StyleBox["33", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[33, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{50, 0}, {60, 23}]},
        ImageSizeCache->{{62.87741312741312, 72.40289575289574}, {
         90.89879468829514, 102.03778676483908`}}],
       StatusArea[#, 23]& ,
       TagBoxNote->"23"],
      StyleBox["23", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[23, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{60, 0}, {70, 18}]},
        ImageSizeCache->{{71.90289575289574, 81.42837837837837}, {
         93.21161905276122, 102.03778676483908`}}],
       StatusArea[#, 18]& ,
       TagBoxNote->"18"],
      StyleBox["18", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[18, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{70, 0}, {80, 13}]},
        ImageSizeCache->{{80.92837837837837, 90.453861003861}, {
         95.52444341722729, 102.03778676483908`}}],
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{80, 0}, {90, 6}]},
        ImageSizeCache->{{89.953861003861, 99.47934362934362}, {
         98.76239752747979, 102.03778676483908`}}],
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{90, 0}, {100, 7}]},
        ImageSizeCache->{{98.97934362934362, 108.50482625482624`}, {
         98.29983265458658, 102.03778676483908`}}],
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{100, 0}, {110, 8}]},
        ImageSizeCache->{{108.00482625482624`, 117.53030888030887`}, {
         97.83726778169337, 102.03778676483908`}}],
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{110, 0}, {120, 11}]},
        ImageSizeCache->{{117.03030888030887`, 126.55579150579149`}, {
         96.44957316301372, 102.03778676483908`}}],
       StatusArea[#, 11]& ,
       TagBoxNote->"11"],
      StyleBox["11", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[11, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{120, 0}, {130, 6}]},
        ImageSizeCache->{{126.05579150579149`, 135.5812741312741}, {
         98.76239752747979, 102.03778676483908`}}],
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{130, 0}, {140, 3}]},
        ImageSizeCache->{{135.0812741312741, 144.60675675675674`}, {
         100.15009214615944`, 102.03778676483908`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{140, 0}, {150, 4}]},
        ImageSizeCache->{{144.10675675675674`, 153.63223938223936`}, {
         99.68752727326623, 102.03778676483908`}}],
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{150, 0}, {160, 2}]},
        ImageSizeCache->{{153.13223938223936`, 162.657722007722}, {
         100.61265701905265`, 102.03778676483908`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{170, 0}, {180, 1}]},
        ImageSizeCache->{{171.1832046332046, 180.70868725868723`}, {
         101.07522189194587`, 102.03778676483908`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{190, 0}, {200, 1}]},
        ImageSizeCache->{{189.23416988416986`, 198.75965250965248`}, {
         101.07522189194587`, 102.03778676483908`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{200, 0}, {210, 1}]},
        ImageSizeCache->{{198.25965250965248`, 207.7851351351351}, {
         101.07522189194587`, 102.03778676483908`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{210, 0}, {220, 2}]},
        ImageSizeCache->{{207.2851351351351, 216.81061776061773`}, {
         100.61265701905265`, 102.03778676483908`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{220, 0}, {230, 1}]},
        ImageSizeCache->{{216.31061776061773`, 225.83610038610036`}, {
         101.07522189194587`, 102.03778676483908`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{240, 0}, {250, 2}]},
        ImageSizeCache->{{234.36158301158298`, 243.8870656370656}, {
         100.61265701905265`, 102.03778676483908`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{260, 0}, {270, 1}]},
        ImageSizeCache->{{252.41254826254823`, 261.9380308880308}, {
         101.07522189194587`, 102.03778676483908`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{280, 0}, {290, 2}]},
        ImageSizeCache->{{270.4635135135135, 279.9889961389961}, {
         100.61265701905265`, 102.03778676483908`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{290, 0}, {300, 1}]},
        ImageSizeCache->{{279.4889961389961, 289.0144787644787}, {
         101.07522189194587`, 102.03778676483908`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{310, 0}, {320, 1}]},
        ImageSizeCache->{{297.5399613899613, 307.065444015444}, {
         101.07522189194587`, 102.03778676483908`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{360, 0}, {370, 1}]},
        ImageSizeCache->{{342.66737451737447`, 352.19285714285706`}, {
         101.07522189194587`, 102.03778676483908`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesOrigin->{0, 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  PlotLabel->FormBox[
   "\"Occurrences vs LGWR pwrite64 duration (ms)\"", TraditionalForm],
  PlotRange->{{0, 370}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.498478803029048*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {{}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], Opacity[0.5], EdgeForm[
     Opacity[0.7]], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0, 0}, {10, 409}]},
         ImageSizeCache->{{88.77083333333331, 
          96.37291666666664}, {-87.66057730480154, 101.94634241294469`}}],
        StatusArea[#, 409]& ,
        TagBoxNote->"409"],
       StyleBox["409", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[409, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{10, 0}, {20, 190}]},
         ImageSizeCache->{{95.87291666666664, 103.47499999999998`}, {
          13.597162103967221`, 101.94634241294469`}}],
        StatusArea[#, 190]& ,
        TagBoxNote->"190"],
       StyleBox["190", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[190, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{20, 0}, {30, 180}]},
         ImageSizeCache->{{102.97499999999998`, 110.5770833333333}, {
          18.22080317286077, 101.94634241294469`}}],
        StatusArea[#, 180]& ,
        TagBoxNote->"180"],
       StyleBox["180", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[180, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{30, 0}, {40, 79}]},
         ImageSizeCache->{{110.0770833333333, 117.67916666666665`}, {
          64.91957796868564, 101.94634241294469`}}],
        StatusArea[#, 79]& ,
        TagBoxNote->"79"],
       StyleBox["79", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[79, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{40, 0}, {50, 33}]},
         ImageSizeCache->{{117.17916666666665`, 124.78124999999997`}, {
          86.18832688559597, 101.94634241294469`}}],
        StatusArea[#, 33]& ,
        TagBoxNote->"33"],
       StyleBox["33", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[33, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{50, 0}, {60, 23}]},
         ImageSizeCache->{{124.28124999999997`, 131.8833333333333}, {
          90.81196795448952, 101.94634241294469`}}],
        StatusArea[#, 23]& ,
        TagBoxNote->"23"],
       StyleBox["23", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[23, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{60, 0}, {70, 18}]},
         ImageSizeCache->{{131.3833333333333, 138.98541666666665`}, {
          93.1237884889363, 101.94634241294469`}}],
        StatusArea[#, 18]& ,
        TagBoxNote->"18"],
       StyleBox["18", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[18, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{70, 0}, {80, 13}]},
         ImageSizeCache->{{138.48541666666665`, 146.08749999999998`}, {
          95.43560902338307, 101.94634241294469`}}],
        StatusArea[#, 13]& ,
        TagBoxNote->"13"],
       StyleBox["13", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[13, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{80, 0}, {90, 6}]},
         ImageSizeCache->{{145.58749999999998`, 153.1895833333333}, {
          98.67215777160855, 101.94634241294469`}}],
        StatusArea[#, 6]& ,
        TagBoxNote->"6"],
       StyleBox["6", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[6, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{90, 0}, {100, 7}]},
         ImageSizeCache->{{152.6895833333333, 160.29166666666663`}, {
          98.2097936647192, 101.94634241294469`}}],
        StatusArea[#, 7]& ,
        TagBoxNote->"7"],
       StyleBox["7", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[7, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{100, 0}, {110, 8}]},
         ImageSizeCache->{{159.79166666666663`, 167.39374999999995`}, {
          97.74742955782985, 101.94634241294469`}}],
        StatusArea[#, 8]& ,
        TagBoxNote->"8"],
       StyleBox["8", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[8, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{110, 0}, {120, 11}]},
         ImageSizeCache->{{166.89374999999995`, 174.49583333333328`}, {
          96.36033723716179, 101.94634241294469`}}],
        StatusArea[#, 11]& ,
        TagBoxNote->"11"],
       StyleBox["11", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[11, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{120, 0}, {130, 6}]},
         ImageSizeCache->{{173.99583333333328`, 181.59791666666663`}, {
          98.67215777160855, 101.94634241294469`}}],
        StatusArea[#, 6]& ,
        TagBoxNote->"6"],
       StyleBox["6", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[6, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{130, 0}, {140, 3}]},
         ImageSizeCache->{{181.09791666666663`, 188.69999999999996`}, {
          100.05925009227663`, 101.94634241294469`}}],
        StatusArea[#, 3]& ,
        TagBoxNote->"3"],
       StyleBox["3", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[3, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{140, 0}, {150, 4}]},
         ImageSizeCache->{{188.19999999999996`, 195.80208333333331`}, {
          99.59688598538727, 101.94634241294469`}}],
        StatusArea[#, 4]& ,
        TagBoxNote->"4"],
       StyleBox["4", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[4, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{150, 0}, {160, 2}]},
         ImageSizeCache->{{195.30208333333331`, 202.90416666666664`}, {
          100.52161419916598`, 101.94634241294469`}}],
        StatusArea[#, 2]& ,
        TagBoxNote->"2"],
       StyleBox["2", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[2, {
         GrayLevel[0]}], "Tooltip"]& ], {}, 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{170, 0}, {180, 1}]},
         ImageSizeCache->{{209.50624999999997`, 217.1083333333333}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ], {}, 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{190, 0}, {200, 1}]},
         ImageSizeCache->{{223.71041666666662`, 231.31249999999997`}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{200, 0}, {210, 1}]},
         ImageSizeCache->{{230.81249999999997`, 238.4145833333333}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{210, 0}, {220, 2}]},
         ImageSizeCache->{{237.9145833333333, 245.51666666666662`}, {
          100.52161419916598`, 101.94634241294469`}}],
        StatusArea[#, 2]& ,
        TagBoxNote->"2"],
       StyleBox["2", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[2, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{220, 0}, {230, 1}]},
         ImageSizeCache->{{245.01666666666662`, 252.61874999999995`}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ], {}, 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{240, 0}, {250, 2}]},
         ImageSizeCache->{{259.2208333333333, 266.82291666666663`}, {
          100.52161419916598`, 101.94634241294469`}}],
        StatusArea[#, 2]& ,
        TagBoxNote->"2"],
       StyleBox["2", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[2, {
         GrayLevel[0]}], "Tooltip"]& ], {}, 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{260, 0}, {270, 1}]},
         ImageSizeCache->{{273.42499999999995`, 281.0270833333333}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ], {}, 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{280, 0}, {290, 2}]},
         ImageSizeCache->{{287.6291666666666, 295.23124999999993`}, {
          100.52161419916598`, 101.94634241294469`}}],
        StatusArea[#, 2]& ,
        TagBoxNote->"2"],
       StyleBox["2", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[2, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{290, 0}, {300, 1}]},
         ImageSizeCache->{{294.73124999999993`, 302.33333333333326`}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ], {}, 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{310, 0}, {320, 1}]},
         ImageSizeCache->{{308.9354166666666, 316.5374999999999}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{360, 0}, {370, 1}]},
         ImageSizeCache->{{344.44583333333327`, 352.0479166666666}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, 
    {RGBColor[0.6, 0.24, 0.4428931686004542], Opacity[0.5], EdgeForm[Opacity[
     0.7]], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-100, 0}, {-90, 1}]},
         ImageSizeCache->{{17.749999999999986`, 25.352083333333326`}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-90, 0}, {-80, 2}]},
         ImageSizeCache->{{24.852083333333326`, 32.45416666666666}, {
          100.52161419916598`, 101.94634241294469`}}],
        StatusArea[#, 2]& ,
        TagBoxNote->"2"],
       StyleBox["2", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[2, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-80, 0}, {-70, 3}]},
         ImageSizeCache->{{31.95416666666666, 39.55624999999999}, {
          100.05925009227663`, 101.94634241294469`}}],
        StatusArea[#, 3]& ,
        TagBoxNote->"3"],
       StyleBox["3", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[3, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-70, 0}, {-60, 7}]},
         ImageSizeCache->{{39.05624999999999, 46.658333333333324`}, {
          98.2097936647192, 101.94634241294469`}}],
        StatusArea[#, 7]& ,
        TagBoxNote->"7"],
       StyleBox["7", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[7, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-60, 0}, {-50, 19}]},
         ImageSizeCache->{{46.158333333333324`, 53.76041666666665}, {
          92.66142438204695, 101.94634241294469`}}],
        StatusArea[#, 19]& ,
        TagBoxNote->"19"],
       StyleBox["19", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[19, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-50, 0}, {-40, 16}]},
         ImageSizeCache->{{53.26041666666665, 60.86249999999998}, {
          94.048516702715, 101.94634241294469`}}],
        StatusArea[#, 16]& ,
        TagBoxNote->"16"],
       StyleBox["16", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[16, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-40, 0}, {-30, 33}]},
         ImageSizeCache->{{60.36249999999998, 67.96458333333332}, {
          86.18832688559597, 101.94634241294469`}}],
        StatusArea[#, 33]& ,
        TagBoxNote->"33"],
       StyleBox["33", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[33, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-30, 0}, {-20, 43}]},
         ImageSizeCache->{{67.46458333333332, 75.06666666666665}, {
          81.56468581670242, 101.94634241294469`}}],
        StatusArea[#, 43]& ,
        TagBoxNote->"43"],
       StyleBox["43", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[43, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-20, 0}, {-10, 67}]},
         ImageSizeCache->{{74.56666666666665, 82.16874999999999}, {
          70.4679472513579, 101.94634241294469`}}],
        StatusArea[#, 67]& ,
        TagBoxNote->"67"],
       StyleBox["67", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[67, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-10, 0}, {0, 69}]},
         ImageSizeCache->{{81.66874999999999, 89.27083333333331}, {
          69.54321903757919, 101.94634241294469`}}],
        StatusArea[#, 69]& ,
        TagBoxNote->"69"],
       StyleBox["69", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[69, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0, 0}, {10, 84}]},
         ImageSizeCache->{{88.77083333333331, 96.37291666666664}, {
          62.60775743423886, 101.94634241294469`}}],
        StatusArea[#, 84]& ,
        TagBoxNote->"84"],
       StyleBox["84", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[84, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{10, 0}, {20, 116}]},
         ImageSizeCache->{{95.87291666666664, 103.47499999999998`}, {
          47.8121060137795, 101.94634241294469`}}],
        StatusArea[#, 116]& ,
        TagBoxNote->"116"],
       StyleBox["116", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[116, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{20, 0}, {30, 94}]},
         ImageSizeCache->{{102.97499999999998`, 110.5770833333333}, {
          57.98411636534531, 101.94634241294469`}}],
        StatusArea[#, 94]& ,
        TagBoxNote->"94"],
       StyleBox["94", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[94, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{30, 0}, {40, 102}]},
         ImageSizeCache->{{110.0770833333333, 117.67916666666665`}, {
          54.28520351023047, 101.94634241294469`}}],
        StatusArea[#, 102]& ,
        TagBoxNote->"102"],
       StyleBox["102", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[102, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{40, 0}, {50, 84}]},
         ImageSizeCache->{{117.17916666666665`, 124.78124999999997`}, {
          62.60775743423886, 101.94634241294469`}}],
        StatusArea[#, 84]& ,
        TagBoxNote->"84"],
       StyleBox["84", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[84, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{50, 0}, {60, 88}]},
         ImageSizeCache->{{124.28124999999997`, 131.8833333333333}, {
          60.75830100668144, 101.94634241294469`}}],
        StatusArea[#, 88]& ,
        TagBoxNote->"88"],
       StyleBox["88", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[88, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{60, 0}, {70, 59}]},
         ImageSizeCache->{{131.3833333333333, 138.98541666666665`}, {
          74.16686010647274, 101.94634241294469`}}],
        StatusArea[#, 59]& ,
        TagBoxNote->"59"],
       StyleBox["59", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[59, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{70, 0}, {80, 37}]},
         ImageSizeCache->{{138.48541666666665`, 146.08749999999998`}, {
          84.33887045803854, 101.94634241294469`}}],
        StatusArea[#, 37]& ,
        TagBoxNote->"37"],
       StyleBox["37", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[37, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{80, 0}, {90, 29}]},
         ImageSizeCache->{{145.58749999999998`, 153.1895833333333}, {
          88.0377833131534, 101.94634241294469`}}],
        StatusArea[#, 29]& ,
        TagBoxNote->"29"],
       StyleBox["29", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[29, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{90, 0}, {100, 23}]},
         ImageSizeCache->{{152.6895833333333, 160.29166666666663`}, {
          90.81196795448952, 101.94634241294469`}}],
        StatusArea[#, 23]& ,
        TagBoxNote->"23"],
       StyleBox["23", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[23, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{100, 0}, {110, 12}]},
         ImageSizeCache->{{159.79166666666663`, 167.39374999999995`}, {
          95.89797313027243, 101.94634241294469`}}],
        StatusArea[#, 12]& ,
        TagBoxNote->"12"],
       StyleBox["12", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[12, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{110, 0}, {120, 12}]},
         ImageSizeCache->{{166.89374999999995`, 174.49583333333328`}, {
          95.89797313027243, 101.94634241294469`}}],
        StatusArea[#, 12]& ,
        TagBoxNote->"12"],
       StyleBox["12", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[12, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{120, 0}, {130, 2}]},
         ImageSizeCache->{{173.99583333333328`, 181.59791666666663`}, {
          100.52161419916598`, 101.94634241294469`}}],
        StatusArea[#, 2]& ,
        TagBoxNote->"2"],
       StyleBox["2", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[2, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{130, 0}, {140, 2}]},
         ImageSizeCache->{{181.09791666666663`, 188.69999999999996`}, {
          100.52161419916598`, 101.94634241294469`}}],
        StatusArea[#, 2]& ,
        TagBoxNote->"2"],
       StyleBox["2", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[2, {
         GrayLevel[0]}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{140, 0}, {150, 1}]},
         ImageSizeCache->{{188.19999999999996`, 195.80208333333331`}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], "Tooltip"]& ], {}, 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{160, 0}, {170, 1}]},
         ImageSizeCache->{{202.40416666666664`, 210.00624999999997`}, {
          100.98397830605533`, 101.94634241294469`}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {
         GrayLevel[0]}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {
         GrayLevel[0]}], 
       "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesOrigin->{-100, 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  PlotLabel->FormBox[
   "\"Occurrences vs LGWR pwrite64 duration (ms)\"", TraditionalForm],
  PlotRange->{{-100, 370}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.498478803429142*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {}, 
   {RGBColor[0.24720000000000014`, 0.24, 0.6], Opacity[0.5], EdgeForm[Opacity[
    0.7]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{0, 0}, {1, 177}]},
        ImageSizeCache->{{17.749999999999996`, 
         20.47628571428571}, {-87.65124624848583, 102.03778676483911`}}],
       StatusArea[#, 177]& ,
       TagBoxNote->"177"],
      StyleBox["177", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[177, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1, 0}, {2, 78}]},
        ImageSizeCache->{{19.97628571428571, 22.702571428571424`}, {
         18.166348487780667`, 102.03778676483911`}}],
       StatusArea[#, 78]& ,
       TagBoxNote->"78"],
      StyleBox["78", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[78, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{2, 0}, {3, 48}]},
        ImageSizeCache->{{22.202571428571424`, 24.92885714285714}, {
         50.2322862866493, 102.03778676483911`}}],
       StatusArea[#, 48]& ,
       TagBoxNote->"48"],
      StyleBox["48", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[48, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{3, 0}, {4, 16}]},
        ImageSizeCache->{{24.42885714285714, 27.155142857142852`}, {
         84.43595327210917, 102.03778676483911`}}],
       StatusArea[#, 16]& ,
       TagBoxNote->"16"],
      StyleBox["16", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[16, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{4, 0}, {5, 15}]},
        ImageSizeCache->{{26.655142857142852`, 29.381428571428565`}, {
         85.50481786540479, 102.03778676483911`}}],
       StatusArea[#, 15]& ,
       TagBoxNote->"15"],
      StyleBox["15", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[15, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{5, 0}, {6, 8}]},
        ImageSizeCache->{{28.881428571428565`, 31.60771428571428}, {
         92.98687001847415, 102.03778676483911`}}],
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{6, 0}, {7, 13}]},
        ImageSizeCache->{{31.10771428571428, 33.833999999999996`}, {
         87.64254705199603, 102.03778676483911`}}],
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{7, 0}, {8, 20}]},
        ImageSizeCache->{{33.333999999999996`, 36.06028571428571}, {
         80.16049489892669, 102.03778676483911`}}],
       StatusArea[#, 20]& ,
       TagBoxNote->"20"],
      StyleBox["20", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[20, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{8, 0}, {9, 21}]},
        ImageSizeCache->{{35.56028571428571, 38.28657142857142}, {
         79.09163030563107, 102.03778676483911`}}],
       StatusArea[#, 21]& ,
       TagBoxNote->"21"],
      StyleBox["21", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[21, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{9, 0}, {10, 13}]},
        ImageSizeCache->{{37.78657142857142, 40.512857142857136`}, {
         87.64254705199603, 102.03778676483911`}}],
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{10, 0}, {11, 17}]},
        ImageSizeCache->{{40.012857142857136`, 42.73914285714285}, {
         83.36708867881356, 102.03778676483911`}}],
       StatusArea[#, 17]& ,
       TagBoxNote->"17"],
      StyleBox["17", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[17, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{11, 0}, {12, 20}]},
        ImageSizeCache->{{42.23914285714285, 44.96542857142856}, {
         80.16049489892669, 102.03778676483911`}}],
       StatusArea[#, 20]& ,
       TagBoxNote->"20"],
      StyleBox["20", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[20, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{12, 0}, {13, 13}]},
        ImageSizeCache->{{44.46542857142856, 47.19171428571428}, {
         87.64254705199603, 102.03778676483911`}}],
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{13, 0}, {14, 15}]},
        ImageSizeCache->{{46.69171428571428, 49.41799999999999}, {
         85.50481786540479, 102.03778676483911`}}],
       StatusArea[#, 15]& ,
       TagBoxNote->"15"],
      StyleBox["15", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[15, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{14, 0}, {15, 16}]},
        ImageSizeCache->{{48.91799999999999, 51.6442857142857}, {
         84.43595327210917, 102.03778676483911`}}],
       StatusArea[#, 16]& ,
       TagBoxNote->"16"],
      StyleBox["16", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[16, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{15, 0}, {16, 17}]},
        ImageSizeCache->{{51.1442857142857, 53.870571428571424`}, {
         83.36708867881356, 102.03778676483911`}}],
       StatusArea[#, 17]& ,
       TagBoxNote->"17"],
      StyleBox["17", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[17, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{16, 0}, {17, 15}]},
        ImageSizeCache->{{53.370571428571424`, 56.09685714285713}, {
         85.50481786540479, 102.03778676483911`}}],
       StatusArea[#, 15]& ,
       TagBoxNote->"15"],
      StyleBox["15", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[15, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{17, 0}, {18, 22}]},
        ImageSizeCache->{{55.59685714285713, 58.323142857142855`}, {
         78.02276571233546, 102.03778676483911`}}],
       StatusArea[#, 22]& ,
       TagBoxNote->"22"],
      StyleBox["22", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[22, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{18, 0}, {19, 29}]},
        ImageSizeCache->{{57.823142857142855`, 60.549428571428564`}, {
         70.5407135592661, 102.03778676483911`}}],
       StatusArea[#, 29]& ,
       TagBoxNote->"29"],
      StyleBox["29", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[29, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{19, 0}, {20, 26}]},
        ImageSizeCache->{{60.049428571428564`, 62.77571428571427}, {
         73.74730733915297, 102.03778676483911`}}],
       StatusArea[#, 26]& ,
       TagBoxNote->"26"],
      StyleBox["26", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[26, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{20, 0}, {21, 17}]},
        ImageSizeCache->{{62.27571428571427, 65.002}, {83.36708867881356, 
         102.03778676483911`}}],
       StatusArea[#, 17]& ,
       TagBoxNote->"17"],
      StyleBox["17", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[17, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{21, 0}, {22, 21}]},
        ImageSizeCache->{{64.502, 67.2282857142857}, {79.09163030563107, 
         102.03778676483911`}}],
       StatusArea[#, 21]& ,
       TagBoxNote->"21"],
      StyleBox["21", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[21, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{22, 0}, {23, 11}]},
        ImageSizeCache->{{66.7282857142857, 69.45457142857141}, {
         89.78027623858728, 102.03778676483911`}}],
       StatusArea[#, 11]& ,
       TagBoxNote->"11"],
      StyleBox["11", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[11, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{23, 0}, {24, 23}]},
        ImageSizeCache->{{68.95457142857141, 71.68085714285714}, {
         76.95390111903983, 102.03778676483911`}}],
       StatusArea[#, 23]& ,
       TagBoxNote->"23"],
      StyleBox["23", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[23, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{24, 0}, {25, 23}]},
        ImageSizeCache->{{71.18085714285714, 73.90714285714284}, {
         76.95390111903983, 102.03778676483911`}}],
       StatusArea[#, 23]& ,
       TagBoxNote->"23"],
      StyleBox["23", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[23, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{25, 0}, {26, 21}]},
        ImageSizeCache->{{73.40714285714284, 76.13342857142857}, {
         79.09163030563107, 102.03778676483911`}}],
       StatusArea[#, 21]& ,
       TagBoxNote->"21"],
      StyleBox["21", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[21, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{26, 0}, {27, 20}]},
        ImageSizeCache->{{75.63342857142857, 78.35971428571428}, {
         80.16049489892669, 102.03778676483911`}}],
       StatusArea[#, 20]& ,
       TagBoxNote->"20"],
      StyleBox["20", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[20, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{27, 0}, {28, 18}]},
        ImageSizeCache->{{77.85971428571428, 80.58599999999998}, {
         82.29822408551793, 102.03778676483911`}}],
       StatusArea[#, 18]& ,
       TagBoxNote->"18"],
      StyleBox["18", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[18, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{28, 0}, {29, 18}]},
        ImageSizeCache->{{80.08599999999998, 82.81228571428571}, {
         82.29822408551793, 102.03778676483911`}}],
       StatusArea[#, 18]& ,
       TagBoxNote->"18"],
      StyleBox["18", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[18, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{29, 0}, {30, 8}]},
        ImageSizeCache->{{82.31228571428571, 85.03857142857142}, {
         92.98687001847415, 102.03778676483911`}}],
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{30, 0}, {31, 13}]},
        ImageSizeCache->{{84.53857142857142, 87.26485714285714}, {
         87.64254705199603, 102.03778676483911`}}],
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{31, 0}, {32, 16}]},
        ImageSizeCache->{{86.76485714285714, 89.49114285714285}, {
         84.43595327210917, 102.03778676483911`}}],
       StatusArea[#, 16]& ,
       TagBoxNote->"16"],
      StyleBox["16", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[16, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{32, 0}, {33, 3}]},
        ImageSizeCache->{{88.99114285714285, 91.71742857142856}, {
         98.33119298495225, 102.03778676483911`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{33, 0}, {34, 12}]},
        ImageSizeCache->{{91.21742857142856, 93.94371428571428}, {
         88.71141164529166, 102.03778676483911`}}],
       StatusArea[#, 12]& ,
       TagBoxNote->"12"],
      StyleBox["12", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[12, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{34, 0}, {35, 8}]},
        ImageSizeCache->{{93.44371428571428, 96.16999999999999}, {
         92.98687001847415, 102.03778676483911`}}],
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{35, 0}, {36, 7}]},
        ImageSizeCache->{{95.66999999999999, 98.39628571428571}, {
         94.05573461176976, 102.03778676483911`}}],
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{36, 0}, {37, 9}]},
        ImageSizeCache->{{97.89628571428571, 100.62257142857142`}, {
         91.91800542517852, 102.03778676483911`}}],
       StatusArea[#, 9]& ,
       TagBoxNote->"9"],
      StyleBox["9", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[9, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{37, 0}, {38, 4}]},
        ImageSizeCache->{{100.12257142857142`, 102.84885714285713`}, {
         97.26232839165662, 102.03778676483911`}}],
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38, 0}, {39, 4}]},
        ImageSizeCache->{{102.34885714285713`, 105.07514285714285`}, {
         97.26232839165662, 102.03778676483911`}}],
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{39, 0}, {40, 3}]},
        ImageSizeCache->{{104.57514285714285`, 107.30142857142856`}, {
         98.33119298495225, 102.03778676483911`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40, 0}, {41, 5}]},
        ImageSizeCache->{{106.80142857142856`, 109.52771428571427`}, {
         96.19346379836101, 102.03778676483911`}}],
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{41, 0}, {42, 3}]},
        ImageSizeCache->{{109.02771428571427`, 111.75399999999999`}, {
         98.33119298495225, 102.03778676483911`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{42, 0}, {43, 4}]},
        ImageSizeCache->{{111.25399999999999`, 113.9802857142857}, {
         97.26232839165662, 102.03778676483911`}}],
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{43, 0}, {44, 3}]},
        ImageSizeCache->{{113.4802857142857, 116.20657142857141`}, {
         98.33119298495225, 102.03778676483911`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{44, 0}, {45, 4}]},
        ImageSizeCache->{{115.70657142857141`, 118.43285714285713`}, {
         97.26232839165662, 102.03778676483911`}}],
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{45, 0}, {46, 4}]},
        ImageSizeCache->{{117.93285714285713`, 120.65914285714284`}, {
         97.26232839165662, 102.03778676483911`}}],
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{46, 0}, {47, 2}]},
        ImageSizeCache->{{120.15914285714284`, 122.88542857142856`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{47, 0}, {48, 5}]},
        ImageSizeCache->{{122.38542857142856`, 125.11171428571427`}, {
         96.19346379836101, 102.03778676483911`}}],
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{48, 0}, {49, 3}]},
        ImageSizeCache->{{124.61171428571427`, 127.33799999999998`}, {
         98.33119298495225, 102.03778676483911`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{51, 0}, {52, 1}]},
        ImageSizeCache->{{131.2905714285714, 134.01685714285713`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{52, 0}, {53, 2}]},
        ImageSizeCache->{{133.51685714285713`, 136.24314285714283`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{53, 0}, {54, 1}]},
        ImageSizeCache->{{135.74314285714283`, 138.46942857142855`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{54, 0}, {55, 6}]},
        ImageSizeCache->{{137.96942857142855`, 140.69571428571427`}, {
         95.12459920506538, 102.03778676483911`}}],
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{55, 0}, {56, 2}]},
        ImageSizeCache->{{140.19571428571427`, 142.92199999999997`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{56, 0}, {57, 1}]},
        ImageSizeCache->{{142.42199999999997`, 145.1482857142857}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{57, 0}, {58, 3}]},
        ImageSizeCache->{{144.6482857142857, 147.37457142857141`}, {
         98.33119298495225, 102.03778676483911`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{58, 0}, {59, 3}]},
        ImageSizeCache->{{146.87457142857141`, 149.60085714285714`}, {
         98.33119298495225, 102.03778676483911`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{59, 0}, {60, 4}]},
        ImageSizeCache->{{149.10085714285714`, 151.82714285714283`}, {
         97.26232839165662, 102.03778676483911`}}],
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{60, 0}, {61, 1}]},
        ImageSizeCache->{{151.32714285714283`, 154.05342857142855`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{61, 0}, {62, 2}]},
        ImageSizeCache->{{153.55342857142855`, 156.27971428571428`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{62, 0}, {63, 1}]},
        ImageSizeCache->{{155.77971428571428`, 158.50599999999997`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{63, 0}, {64, 1}]},
        ImageSizeCache->{{158.00599999999997`, 160.7322857142857}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{64, 0}, {65, 2}]},
        ImageSizeCache->{{160.2322857142857, 162.95857142857142`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{65, 0}, {66, 1}]},
        ImageSizeCache->{{162.45857142857142`, 165.1848571428571}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{66, 0}, {67, 1}]},
        ImageSizeCache->{{164.6848571428571, 167.41114285714283`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{67, 0}, {68, 3}]},
        ImageSizeCache->{{166.91114285714283`, 169.63742857142856`}, {
         98.33119298495225, 102.03778676483911`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{69, 0}, {70, 6}]},
        ImageSizeCache->{{171.36371428571425`, 174.08999999999997`}, {
         95.12459920506538, 102.03778676483911`}}],
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{70, 0}, {71, 2}]},
        ImageSizeCache->{{173.58999999999997`, 176.3162857142857}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{71, 0}, {72, 2}]},
        ImageSizeCache->{{175.8162857142857, 178.54257142857142`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{72, 0}, {73, 1}]},
        ImageSizeCache->{{178.04257142857142`, 180.76885714285712`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{73, 0}, {74, 2}]},
        ImageSizeCache->{{180.26885714285712`, 182.99514285714284`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{75, 0}, {76, 1}]},
        ImageSizeCache->{{184.72142857142856`, 187.44771428571426`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{76, 0}, {77, 3}]},
        ImageSizeCache->{{186.94771428571426`, 189.67399999999998`}, {
         98.33119298495225, 102.03778676483911`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{77, 0}, {78, 1}]},
        ImageSizeCache->{{189.17399999999998`, 191.9002857142857}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{78, 0}, {79, 1}]},
        ImageSizeCache->{{191.4002857142857, 194.1265714285714}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{81, 0}, {82, 2}]},
        ImageSizeCache->{{198.07914285714284`, 200.80542857142854`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{82, 0}, {83, 1}]},
        ImageSizeCache->{{200.30542857142854`, 203.03171428571426`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{84, 0}, {85, 1}]},
        ImageSizeCache->{{204.75799999999998`, 207.48428571428568`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{88, 0}, {89, 1}]},
        ImageSizeCache->{{213.66314285714282`, 216.38942857142854`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{89, 0}, {90, 1}]},
        ImageSizeCache->{{215.88942857142854`, 218.61571428571426`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{90, 0}, {91, 2}]},
        ImageSizeCache->{{218.11571428571426`, 220.84199999999998`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{93, 0}, {94, 1}]},
        ImageSizeCache->{{224.7945714285714, 227.52085714285712`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{94, 0}, {95, 1}]},
        ImageSizeCache->{{227.02085714285712`, 229.74714285714282`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{95, 0}, {96, 1}]},
        ImageSizeCache->{{229.24714285714282`, 231.97342857142854`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{96, 0}, {97, 1}]},
        ImageSizeCache->{{231.47342857142854`, 234.19971428571426`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{99, 0}, {100, 1}]},
        ImageSizeCache->{{238.15228571428568`, 240.8785714285714}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{100, 0}, {101, 1}]},
        ImageSizeCache->{{240.3785714285714, 243.1048571428571}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{101, 0}, {102, 2}]},
        ImageSizeCache->{{242.6048571428571, 245.33114285714282`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{103, 0}, {104, 1}]},
        ImageSizeCache->{{247.05742857142855`, 249.78371428571427`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{104, 0}, {105, 2}]},
        ImageSizeCache->{{249.28371428571427`, 252.00999999999996`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{107, 0}, {108, 2}]},
        ImageSizeCache->{{255.96257142857138`, 258.6888571428571}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{110, 0}, {111, 2}]},
        ImageSizeCache->{{262.64142857142855`, 265.3677142857142}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{111, 0}, {112, 1}]},
        ImageSizeCache->{{264.8677142857142, 267.59399999999994`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{112, 0}, {113, 2}]},
        ImageSizeCache->{{267.09399999999994`, 269.82028571428566`}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{113, 0}, {114, 1}]},
        ImageSizeCache->{{269.32028571428566`, 272.0465714285714}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{115, 0}, {116, 1}]},
        ImageSizeCache->{{273.7728571428571, 276.49914285714283`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{116, 0}, {117, 1}]},
        ImageSizeCache->{{275.99914285714283`, 278.72542857142855`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{117, 0}, {118, 2}]},
        ImageSizeCache->{{278.22542857142855`, 280.9517142857143}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{118, 0}, {119, 1}]},
        ImageSizeCache->{{280.4517142857143, 283.17799999999994`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{120, 0}, {121, 1}]},
        ImageSizeCache->{{284.90428571428566`, 287.6305714285714}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{121, 0}, {122, 2}]},
        ImageSizeCache->{{287.1305714285714, 289.8568571428571}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{123, 0}, {124, 1}]},
        ImageSizeCache->{{291.58314285714283`, 294.30942857142855`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{128, 0}, {129, 2}]},
        ImageSizeCache->{{302.7145714285714, 305.4408571428571}, {
         99.40005757824787, 102.03778676483911`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{130, 0}, {131, 1}]},
        ImageSizeCache->{{307.16714285714284`, 309.89342857142856`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{133, 0}, {134, 1}]},
        ImageSizeCache->{{313.84599999999995`, 316.57228571428567`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{138, 0}, {139, 1}]},
        ImageSizeCache->{{324.9774285714285, 327.7037142857142}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{143, 0}, {144, 1}]},
        ImageSizeCache->{{336.1088571428571, 338.83514285714284`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{145, 0}, {146, 1}]},
        ImageSizeCache->{{340.5614285714285, 343.28771428571423`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{146, 0}, {147, 1}]},
        ImageSizeCache->{{342.78771428571423`, 345.51399999999995`}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{148, 0}, {149, 1}]},
        ImageSizeCache->{{347.2402857142857, 349.9665714285714}, {
         100.4689221715435, 102.03778676483911`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesOrigin->{0, 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  PlotLabel->FormBox[
   "\"Occurrences vs LGWR pwrite64 duration (ms)\"", TraditionalForm],
  PlotRange->{{0, 150}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.498478804109673*^9}],

Cell[BoxData["1006"], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.498478804137187*^9}],

Cell[BoxData["24.710299204771374`"], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.498478804171468*^9}],

Cell[BoxData["15.651499999999999`"], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.498478804205546*^9}],

Cell[BoxData["0.507`"], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.4984788042399797`*^9}],

Cell[BoxData["1.955`"], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.498478804273608*^9}],

Cell[BoxData["15.545`"], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.4984788043058853`*^9}],

Cell[BoxData["28.203`"], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.498478804341226*^9}],

Cell[BoxData["31.64`"], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.498478804373334*^9}],

Cell[BoxData["57.643`"], "Output",
 CellChangeTimes->{{3.498442491279937*^9, 3.498442506600882*^9}, 
   3.498442852395556*^9, 3.498442906675561*^9, {3.498442995121286*^9, 
   3.498443005964015*^9}, 3.49844304500086*^9, 3.4984430781004066`*^9, 
   3.498443277688696*^9, 3.498443383391938*^9, 3.498443462606062*^9, {
   3.498443556263482*^9, 3.498443591317213*^9}, 3.498444266237762*^9, 
   3.498444346016108*^9, {3.498446037151762*^9, 3.498446056092057*^9}, {
   3.4984460939385023`*^9, 3.498446142721716*^9}, {3.4984461825657063`*^9, 
   3.498446238128202*^9}, 3.498446306973976*^9, {3.4984463539400177`*^9, 
   3.498446388603533*^9}, 3.4984464390006123`*^9, {3.498446474374303*^9, 
   3.4984464947425623`*^9}, {3.4984465815844088`*^9, 3.498446660734056*^9}, 
   3.4984467610287743`*^9, {3.498478290650264*^9, 3.498478330945566*^9}, 
   3.498478368128319*^9, 3.4984784066748657`*^9, 3.498478759246234*^9, 
   3.4984788044084787`*^9}]
}, Open  ]]
},
WindowSize->{657, 1070},
WindowMargins->{{Automatic, 346}, {Automatic, 16}},
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 3321, 83, 313, "Input"],
Cell[3891, 107, 18243, 571, 253, "Output"],
Cell[22137, 680, 35644, 1095, 253, "Output"],
Cell[57784, 1777, 69255, 2231, 253, "Output"],
Cell[127042, 4010, 928, 13, 27, "Output"],
Cell[127973, 4025, 943, 13, 27, "Output"],
Cell[128919, 4040, 943, 13, 27, "Output"],
Cell[129865, 4055, 932, 13, 27, "Output"],
Cell[130800, 4070, 930, 13, 27, "Output"],
Cell[131733, 4085, 933, 13, 27, "Output"],
Cell[132669, 4100, 931, 13, 27, "Output"],
Cell[133603, 4115, 930, 13, 27, "Output"],
Cell[134536, 4130, 933, 13, 27, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
